var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
};
var _onClose, _onData;
import Observable from "./observable.js";
import Signal from "./signal.js";
export default class AsyncIteratorFromCB {
    constructor() {
        _onClose.set(this, []);
        _onData.set(this, new Observable());
    }
    onClose(callback) {
        __classPrivateFieldGet(this, _onClose).push(callback);
    }
    getCallback() {
        return (error, data) => {
            __classPrivateFieldGet(this, _onData).send({ error, data, close: undefined });
        };
    }
    send(data) {
        __classPrivateFieldGet(this, _onData).send({
            error: undefined,
            data,
            close: undefined,
        });
    }
    close() {
        __classPrivateFieldGet(this, _onData).send({
            close: true,
            data: undefined,
            error: undefined,
        });
        __classPrivateFieldGet(this, _onData).close();
        __classPrivateFieldGet(this, _onClose).forEach((cb) => cb());
    }
    [(_onClose = new WeakMap(), _onData = new WeakMap(), Symbol.asyncIterator)]() {
        const queue = [];
        const signal = new Signal();
        __classPrivateFieldGet(this, _onData).subscribe((data) => {
            queue.push(data);
            signal.sendSignal();
        });
        return {
            next() {
                return __awaiter(this, void 0, void 0, function* () {
                    const send = () => {
                        const value = queue.shift();
                        if (!value)
                            throw new Error("Error in AsyncIter");
                        if (value.close) {
                            return {
                                done: true,
                                value: undefined,
                            };
                        }
                        else if (value.error) {
                            throw value.error;
                        }
                        else {
                            return {
                                done: false,
                                value: value.data,
                            };
                        }
                    };
                    if (queue.length > 0) {
                        return send();
                    }
                    else {
                        yield signal.awaitSignal();
                        return send();
                    }
                });
            },
        };
    }
}
//# sourceMappingURL=asynciter.js.map